import os,sys
abs_path = os.path.abspath(sys.argv[0])
basename = os.path.basename(sys.argv[0])
dirname = abs_path.replace(basename, "")
if not "%s/diskmon/lib" % dirname in sys.path:
   sys.path.append("%s/diskmon/lib" % dirname) # always with regard to parent script
if not "/usr/bp/lib/monitoring" in sys.path:
   sys.path.append("/usr/bp/lib/monitoring")

class CONFIG:   pass

import commands      
lines = commands.getoutput("/bin/ps aux | /bin/grep postgres | /bin/grep data").splitlines()
CONFIG.dbON = True
CONFIG.dbVacuum =False
# psql: could not fork new process for connection: Cannot allocate memory
# True 1 ['root      9314  0.0  0.0  63848  1048 pts/2    S+   09:34   0:00 sh -c { ps aux | grep postgres | grep data; } 2>&1']

lcnt = 0
for line in lines:
   if "grep" in line:       continue
   lcnt +=1
   
if not lcnt:  CONFIG.dbON = False

# without bpdb postgres, you will see the following message from crontab:
# psql: FATAL:  role "root" does not exist
lines= commands.getoutput("/usr/bin/psql bpdb postgres -c \"select * from bp.nodes limit 1\"").splitlines()
for line in lines:
   if "could not access status of transaction" in line or "timeout expired" in line or "Connection refused" in line or "the database system is starting up" in line or "too many clients" in line:
      CONFIG.dbON = False
      break
      

# Do not run while VACUUM is running
lines = commands.getoutput("/bin/ps aux | /bin/grep VACUUM | /bin/grep -v grep").splitlines()
if len(lines):
   CONFIG.dbON=False
   CONFIG.dbVacuum=True

CONFIG.network_reachable=True
if os.path.exists("/root/payload") and os.path.exists("/root/pl_tracker"):
   CONFIG.network_reachable=False
else:
   _ftpSite = "ftp.unitrends.com"
   lines=commands.getoutput("/bin/ping %s -W 1 -c 1 2>&1 | /bin/grep -E 'Unreachable|100%% packet loss|unknown host' " %_ftpSite).splitlines()
   if len(lines):
      CONFIG.network_reachable=False
   
CONFIG.verbose,CONFIG.debug,CONFIG.confirm,CONFIG.selfhealing = False,False,False,False
CONFIG.CentOS_version = 5
if "el6" in commands.getoutput("/bin/uname -r").splitlines()[0]:
   CONFIG.CentOS_version = 6
CONFIG.ver_info,CONFIG.psaON ="",""

if os.path.exists("/usr/local/bin/dpu"):
   command = "/usr/local/bin/dpu version"
   versions = commands.getoutput(command).splitlines()
   CONFIG.ver_info   = '%s %s' % (versions[1], (versions[2])[13:])

if "line" in CONFIG.ver_info or "rpm" in CONFIG.ver_info or "dpu" in CONFIG.ver_info or "Thread" in CONFIG.ver_info or not len(CONFIG.ver_info):
   if os.path.exists("/var/log/install-rr.log"):
      line=commands.getoutput("grep unitrends-rr /var/log/install-rr.log | grep END |tail -1").splitlines()[0]
      sgs=line.split()
      for i in range(len(sgs)-1,0,-1):
         if "CentOS" in sgs[i]:
            CONFIG.ver_info="Version %s " % sgs[i]
            break
      CONFIG.ver_info+=line.split(" on ")[1]

CONFIG.majorVersion,CONFIG.versionDate = 0,0
if "Version" in CONFIG.ver_info:
   words=CONFIG.ver_info.split()
   CONFIG.majorVersion=float(words[1].split("-")[0][:-2])
   words=CONFIG.ver_info.split(".")
   if "CentOS" not in words[3]:
      CONFIG.versionDate=int( words[3] )

#################

def get_hex(value,n_digit):
   hex_value=hex(value)[2:]
   for i in range(n_digit-len(hex_value)):
      hex_value="0"+hex_value
   return hex_value


import platform
CONFIG.hostname = platform.node()
CONFIG.assetTag = "000-000-00000"   
CONFIG.modelNo  = "000"
if os.path.exists("/etc/unitrends-asset"):
   CONFIG.assetTag  = open("/etc/unitrends-asset").read().split()[0]   
   CONFIG.modelNo   = open('/etc/unitrends-asset').read().split("-")[0]


CONFIG.ipaddr,CONFIG.macAddr,defaultdevice = "10.10.10.1","MAC NA",""
awk_path='/bin/awk'
if not os.path.exists(awk_path):
   awk_path='/usr/bin/awk'
lines =commands.getoutput("/sbin/ip route | %s '/default/ {print $5}' | /usr/bin/head -n 1" % awk_path).splitlines()
if len(lines) >0:
   defaultdevice=lines[0].split()[0]
   lines=commands.getoutput("/sbin/ip addr show dev %s | %s '/inet.+global/ {print $2}' | /usr/bin/cut -f1 -d'/'"%(defaultdevice,awk_path)).splitlines()
   CONFIG.ipaddr=lines[0].split()[0]
   lines=commands.getoutput("/sbin/ip addr show dev %s | %s '/ether/ {print $2}' "% (defaultdevice,awk_path)).splitlines()
   CONFIG.macAddr= (lines[0].split()[0]).upper()

CONFIG.hostType = "Unknown"
if CONFIG.dbON:
   lines = commands.getoutput("/usr/bin/psql -U postgres bpdb -tq -c  \"select item_value from bp.nvp where item_name='Identity'\" | head -1").splitlines()
   if len(lines):
      CONFIG.hostType = lines[0].strip()

   lines = commands.getoutput("/usr/bin/psql -U postgres bpdb -tq -c \"SELECT psa_tool_name FROM bp.psa_config JOIN bp.psa_tools USING (psa_tool_id) WHERE is_default=true\" | grep -v ^$").splitlines()   
   if len(lines):
      words = lines[0].split()
      CONFIG.psaON=words[0].strip()

ibase, iretired    =0,2
directory_paths = ["/var/log/monitoring_disks", "/usr/share/smartmontools", "/var/log/monitoring_disks/old"] # the second one for /usr/sbin/update-smart-drivedb -v

maxMediaWearout     = 50
maxReallocNumber512 = 2000
maxReallocNumberAF  = 30000
maxPendingSector512 = 1  # search with raid.pendingDisk only for LSI
maxPendingSectorAF  = 8  # search with raid.pendingDisk only for LSI
minSERScore = 31

CONFIG.scriptVersion = "20161117_1700"
CONFIG.cvsversion = 91005 # 7.3.0-0 "20140905_1544"

# config for alerting way
CONFIG.delayedAlert = True

# broadcasting configurables
CONFIG.directory_paths = directory_paths
CONFIG.ibase    = ibase
CONFIG.iretired = iretired
configFile         = "%s/diskConfig.ini"         % CONFIG.directory_paths[CONFIG.ibase] 
lsiLogfile         = "%s/lsiController.info.log" % CONFIG.directory_paths[CONFIG.ibase]
twcliLogfile       = "%s/twcli.show.alarms.log"  % CONFIG.directory_paths[CONFIG.ibase]
selfhealingLogfile = "%s/selfhealing.log"        % CONFIG.directory_paths[CONFIG.ibase]
swrebuild_logfile  = "%s/swrebuild_logfile.log"        % CONFIG.directory_paths[CONFIG.ibase]

CONFIG.configFile          = configFile
CONFIG.lsiLogfile          = lsiLogfile
CONFIG.twcliLogfile        = twcliLogfile
CONFIG.selfhealingLogfile  = selfhealingLogfile
CONFIG.swrebuild_logfile   = swrebuild_logfile

CONFIG.maxMediaWearout     =   maxMediaWearout   
CONFIG.maxReallocNumber512 =   maxReallocNumber512 
CONFIG.maxReallocNumberAF  =   maxReallocNumberAF  
CONFIG.maxPendingSector512 =   maxPendingSector512
CONFIG.maxPendingSectorAF  =   maxPendingSectorAF
CONFIG.minSERScore            = minSERScore 
CONFIG.prStatus               = ""
CONFIG.tw_cli_Status          = ""

CONFIG.Enable_raidInfo=True  # default is True

import datetime, time
CONFIG.epochNow = time.time()
CONFIG.now = datetime.datetime.now()
CONFIG.scsi_devices=[]
CONFIG.miniSAS_port=""

# DASTATUS check
days_dastatus=-9999
dastatus_filename="/usr/bp/lists.dir/.dastatus"
if not os.path.exists(dastatus_filename):
   if CONFIG.network_reachable:  # This one could hang in development machine not having correct license
      os.system("/usr/local/bin/dpu dastatus > /dev/null 2>&1")
      
if os.path.exists("/etc/unitrends-asset") and os.path.exists(dastatus_filename):
   lines=commands.getoutput("grep `cat /etc/unitrends-asset` %s" %dastatus_filename).splitlines()
   if len(lines):
      words=(lines[0]).split(",")
      expdate=''
      if len(words)>1:  expdate=words[1].strip()  # this handles zero character or white space character
      if not len(expdate):
         days_dastatus=9999
      else:
         lic_exp_date=datetime.datetime(int(expdate[0:4]),int(expdate[4:6]),int(expdate[6:8]))
         lic_exp_date+=datetime.timedelta(days=1)  # Give extra day due to extra hours in now
         delta =lic_exp_date-CONFIG.now
         #repr(delta):: datetime.timedelta(254, 51324, 276974)
         delta_days= ( ( repr(delta) ).split("delta(")[1] ).split(",")[0]
         days_dastatus=int(delta_days)

support_string="SP"
if days_dastatus<0: support_string="US"
support_string="{%s:%d}" %(support_string,days_dastatus)
support_string=support_string
ipsegs=CONFIG.ipaddr.split(".")
CONFIG.asset_mac ='%s %s'   % (CONFIG.assetTag, CONFIG.macAddr)
CONFIG.asset_mac+=' :%s:%s' % (get_hex(int(ipsegs[2]),2).upper(), get_hex(int(ipsegs[3]),2).upper())
CONFIG.asset_mac+=' %s'     % (support_string)

CONFIG.host_type  ='%s %s' % (CONFIG.hostname, CONFIG.hostType)

segs = CONFIG.assetTag.split("-")
CONFIG.UB_type,UB_license_type ="","N/A"
if "Metal-" in CONFIG.assetTag:
   CONFIG.UB_type="Metal"

import commands      
if len(segs) >3: # this is for UB #60b099ac-7e7e-42dd-bb96-bda073927077
   if len(commands.getoutput("/sbin/lsmod | /bin/grep vmxnet").splitlines()):
      CONFIG.UB_type = "VMWare"
   elif len(commands.getoutput("/sbin/lsmod | /bin/grep vmbus").splitlines()):  
      CONFIG.UB_type = "HyperV"
   elif len(commands.getoutput("/sbin/lsmod |grep xen_netfront")):
      CONFIG.UB_type = "XenSer"

   bptool_lines=commands.getoutput("/usr/bp/bin/bptool -v 2>&1| /bin/grep -E 'Feature:'").splitlines()
   if len(bptool_lines):
      theLine =bptool_lines[0]
      #Feature:  ENTRB,MUX=10,VC=INF,RC=INF,D2D=INF,ENC,ADX
      theWord =theLine.split()[1]
      UB_license_type =theWord.split(",")[0]

if not len(CONFIG.UB_type):
   lines=commands.getoutput("/bin/grep Server1 /var/log/install-rr.log | /bin/grep 'set to'").splitlines()
   if len(lines):
      theWord=(lines[0]).split()[3]
      if "Xen"    in theWord: CONFIG.UB_type="XenSer"
      if "VMware" in theWord: CONFIG.UB_type="VMWare"
      if "Hyper"  in theWord: CONFIG.UB_type="HyperV"
      
CONFIG.host_type +=" %s %s" % (CONFIG.UB_type, UB_license_type)


def get_SCSI_device_address(deviceShort):
    #lrwxrwxrwx 1 root root 0 Feb 26 16:24 /sys/block/sdc/device -> ../../devices/pci0000:00/0000:00:03.0/0000:06:00.0/host6/target6:0:0/6:0:0:0
    readlinkPath = "/usr/bin"
    if CONFIG.CentOS_version == 6:
        readlinkPath = "/bin"
    link = get_printout("%s/readlink -f /sys/block/%s/device" % (readlinkPath, deviceShort))[0] # link = ../../devices/pci0000:00/0000:00:03.0/0000:06:00.0/host6/target6:0:0/6:0:0:0
    theAddress = find_word_wrt_key("host", link, "/", -1)      # theAddress = 0000:06:00.0 
    words = theAddress.split(":")
    shortAddress = ''
    if len(words)>2:
        shortAddress = words[1] + ":" + words[2]  # 06:00.0
    else:
        #[root@bu01 ~]#  /usr/bin/readlink -f /sys/block/sdh/device
        #/sys/devices/platform/host11/session1/target11:0:0/11:0:0:0
        #[root@bu01 ~]# cat /sys/block/sdh/device/vendor
        #FreeBSD
        #-- returning platform somehow.....
        shortAddress = words[0]

    return shortAddress

def get_hostnumber(deviceShort):
   for scsi in CONFIG.scsi_devices:
      if deviceShort in scsi.device:   return scsi.hostNumber

CONFIG.firstHostN_AHCI=-9

class SCSI:
   def __init__(self, line, device_class=""):
      words=line.split()
      addr=words[0]
      self.addr   =addr[1:-1]
      self.type   =words[1]
      self.vendor =words[2]
      self.vendor0 =words[2]  # vendor0 will retain the original vendor name to inform /dev/twl0 instead of /dev/twaN correctly in case of 9750.
      self.version=words[len(words)-2]
      self.device =words[len(words)-1]
      self.vdNumber = int(self.addr.split(":")[2])
      self.rotational=True
      self.device_class=device_class
      #self.classType=""  # This is for placeholder toward class defined in hotplug  long term plan
      
      string=""
      for i in range(len(words)):
         if i<3 or i>len(words)-3: continue
         string+=words[i]+"_"
      string = string[0:-1]
      self.model=string

      self.deviceShort,self.path, theCommand ="","",""
      if "/dev/" in self.device:
         self.deviceShort=self.device.split("/dev/")[1]

      scsiAddresses=commands.getoutput("/bin/ls /sys/class/scsi_device").splitlines()
      for scsiAddress in scsiAddresses:
         if CONFIG.CentOS_version==5:
            theCommand="/usr/bin/readlink -f /sys/class/scsi_device/%s/device" %scsiAddress
         elif CONFIG.CentOS_version==6:
            theCommand="/bin/readlink -f /sys/class/scsi_device/%s" %scsiAddress

         thePath=commands.getoutput(theCommand).splitlines()[0]
         # Confusion could happen over 2:0:0:0 and 12:0:0:0
         # /sys/devices/pci0000:00/0000:00:1f.2/host2/target2:0:0/2:0:0:0
         # /sys/devices/pci0000:00/0000:00:05.0/0000:03:00.0/0000:04:00.0/host12/target12:0:0/12:0:0:0
         
         if "/%s"%self.addr in thePath:  # self.addr="2:0:0:0"
            self.path=thePath
            break

      self.mdraid_OS=False
      self.mdraid_Archive=False
      for line in commands.getoutput("/bin/cat /proc/mdstat | grep md").splitlines():
         words =line.split()
         mddevices=[]
         for word in words:
            if not "sd" in word: continue
            theDevice =word.split("[")[0]
            mddevices.append(theDevice[:-1])
         if self.deviceShort in mddevices:
            if "md99" in line:
               self.mdraid_Archive=True
            elif "md" in line:
               self.mdraid_OS=True

      words=self.path.split("/")
      theIdx, self.hostNumber, self.hostNumber_suffix, self.pciAddr, self.parentPciAddr =-9,-1,"","",""
      self.pciItem, self.parentPciItem="",""
      for i in range(len(words)):
         word=words[i]
         if "host" in word: theIdx=i
      if theIdx>=0:
         self.hostNumber=int(words[theIdx].split("host")[1])
         self.pciAddr=words[theIdx-1]   #0000:08:00.0
         if not "platform" in self.pciAddr:
            self.pciAddr=self.pciAddr[5:]  #08:00.0
         if not "pci" in words[theIdx-2]:
            self.parentPciAddr=words[theIdx-2]
         if os.path.exists("/sys/block/%s/queue/rotational" % self.deviceShort):
            self.rotational=int(get_first_word("/bin/cat /sys/block/%s/queue/rotational" % self.deviceShort))

      for line in commands.getoutput("/sbin/lspci").splitlines():
         if len(self.pciAddr) and self.pciAddr in line:
            self.pciItem=line
         if len(self.parentPciAddr) and self.parentPciAddr in line:
            self.parentPciItem=line
      #print self.pciItem      
      if self.vendor=="LSI" and "9750" in self.model:
         self.vendor="AMCC"  # to enable tw_cli
      self.usage="NA"
      if self.mdraid_OS:
         self.usage="SWOS"
      if "Silicon" in self.pciItem:
         self.usage="eSATA"

      # This is due to miniSAS card sharing common host number over multiple devices
      # lspci | grep LSI
      #      01:00.0 Serial Attached SCSI controller: LSI Logic / Symbios Logic SAS2004 PCI-Express Fusion-MPT SAS-2 [Spitfire] (rev 03)   #LSI 9211
      #lrwxrwxrwx 1 root root 0 Sep 22 16:30 /sys/block/sdg -> ../devices/pci0000:00/0000:00:01.0/0000:01:00.0/host0/port-0:4/end_device-0:4/target0:0:4/0:0:4:0/block/sdg
      #lrwxrwxrwx 1 root root 0 Sep 22 16:30 /sys/block/sdh -> ../devices/pci0000:00/0000:00:01.0/0000:01:00.0/host0/port-0:5/end_device-0:5/target0:0:5/0:0:5:0/block/sdh
      if len(CONFIG.miniSAS_port):
         if CONFIG.miniSAS_port in self.path:
            segment =self.path.split("host%d/port-%d:" % (self.hostNumber, self.hostNumber))[1]
            self.hostNumber_suffix =segment.split("/")[0]
            self.usage="eSATA"
            
   def __repr__(self):
      #scsiAddr   
      #0:0:0:0    disk  LSI (LSI)    9750-4i DISK    5.12 /dev/sda    0000:08:00.0
      return "%10s %8s  %10s (%10s) %20s %7s %10s  %s %s ::%s  %d _%s" %(self.addr, self.type, self.vendor, self.vendor0, self.model, self.version, self.device, self.pciItem, self.pciAddr, \
                                                                    self.usage, self.hostNumber, self.hostNumber_suffix)
#########
from optparse import OptionParser, SUPPRESS_HELP
def get_parser(sys_argv):

# New logic based on proc_name in CentOS6 extended to CentOS5
   N_scsi_host=0
   if int(commands.getoutput("/bin/ls /sys/class/scsi_host/ | /usr/bin/wc -l").splitlines()[0]):  #XenServer UB doesn't have this
      N_scsi_host=int(commands.getoutput("/bin/ls /sys/class/scsi_host/host*/proc_name | /usr/bin/wc -l").splitlines()[0])
   for i in range(N_scsi_host):
      filename="/sys/class/scsi_host/host%d/proc_name" %i
      if os.path.exists(filename):
         proc_name=get_first_word("cat %s" %filename)
         if CONFIG.firstHostN_AHCI < 0:
            if "ahci" in proc_name or "ata_piix" in proc_name:
               CONFIG.firstHostN_AHCI=i
               break
   CONFIG.miniSAS_port=get_first_word("/sbin/lspci | grep 'LSI Logic / Symbios Logic SAS2004 PCI-Express Fusion-MPT SAS-2'")

   util_path="%s/diskmon/lib/util.sh" % dirname
   if not os.path.exists(util_path):
      util_path="/usr/bp/lib/monitoring/lib/util.sh"
   device_class=""
   if os.path.exists("/usr/bin/lsscsi"):
      for line in commands.getoutput("/usr/bin/lsscsi").splitlines():

         segs=line.split()
         deviceName=segs[len(segs)-1].strip()
         if deviceName=="-":
            continue
         device=deviceName.split("/")[2]
         rets=commands.getoutput("%s --device_scan %s" %(util_path,device) ).splitlines()

         #   0x0104   RAID bus controller            ==> 3ware single in legacy 2U-,3U-,5U-   
         #   0x0106   SATA controller                ==> OnBoard SATA
         #   0x0107   Serial Attached SCSI controller==> MiniSAS controller
         #   0x0180   Mass storage controller        ==>eSATA
         #   0x0c03   USB controller                 ==>USB       

         #[root@unitrends01 tmp]# /tmp//diskmon/lib/util.sh --device_scan sdd
         #35139354624
         #L0grxY2JuBckic3U
         #SCST_BIO
         #

         if len(rets)==4:
            device_class=rets[3].strip()
            prefix=device_class[0:6]
            if prefix not in ['0x0104','0x0106','0x0107','0x0180','0x0c03']:
               continue
         elif os.path.exists(util_path):  # util.sh available but rets lines less than 4...
            continue

         CONFIG.scsi_devices.append(SCSI(line,device_class))
   else:
      maps=[]
      for line in get_printout("/bin/ls /sys/block/ | grep s"):  # sda, sdb....
         deviceShort =line.split()[0]
         readlinkPath = "/usr/bin"
         if CONFIG.CentOS_version == 6:
            readlinkPath = "/bin"
         link = get_first_word("%s/readlink -f /sys/block/%s/device" % (readlinkPath, deviceShort)) # link = ../../devices/pci0000:00/0000:00:03.0/0000:06:00.0/host6/target6:0:0/6:0:0:0
         words=link.split("/")
         # /sys/devices/pci0000:00/0000:00:01.0/0000:01:00.0/host0/target0:2:0/0:2:0:0
         maps.append( (words[len(words)-1], deviceShort) )
    
      scsi_no, channel, idx, lun =0,0,0,0
      braket,vendor,model,version,scsi_type ="","","","",""
      for line in get_printout("/bin/cat /proc/scsi/scsi | grep -v 'Attached devices:'"):
         words=line.split()
         if "Host" in line:
            scsi_no, channel, idx, lun = int((words[1])[4:]), int(words[3]), int(words[5]), int(words[7])
            braket="[%d:%d:%d:%d]" %(scsi_no, channel, idx, lun)
         if "Vendor" in line:
            vendor=words[1]
            for i in range(len(words)):
               if i<3 or i>len(words)-3: continue
               model+=words[i]+"_"
            model = model[0:-1]
            version = words[len(words)-1]
         if "Type" in line:
            if "Direct-Access" in words[1]:
               scsi_type="disk"
            elif "CD-ROM" in words[1]:
               scsi_type="cd/dvd"

            device=''
            for aMap in maps:
               if aMap[0] in braket:
                  device=aMap[1]
            if device.strip()=="-":
               continue
            rets=commands.getoutput("%s --device_scan %s" %(util_path,device) ).splitlines()

            #   0x0104   RAID bus controller            ==> 3ware single in legacy 2U-,3U-,5U-   
            #   0x0106   SATA controller                ==> OnBoard SATA
            #   0x0107   Serial Attached SCSI controller==> MiniSAS controller
            #   0x0180   Mass storage controller        ==>eSATA
            #   0x0c03   USB controller                 ==>USB       
            if len(rets)==4:
               device_class=rets[3].strip()
               prefix=device_class[0:6]
               if prefix not in ['0x0104','0x0106','0x0107','0x0180','0x0c03']:
                  continue
            else:
               continue
                  
            CONFIG.scsi_devices.append(SCSI("%s    %6s  %10s  %20s %5s  /dev/%s" %(braket, scsi_type, vendor, model, version, device),device_class))
            scsi_no, channel, idx, lun =0,0,0,0
            braket=""
            vendor, model, version ="","",""
            scsi_type=""

   #outlog= "Model_Idx 
   #Temperature
   #Raw number of seek error count
   #Raw number of seek attempt
   #Raw number of read error count
   #Raw number of read attempt
   #Total MiB Written
   #Total MiB Read
   #Number of power cycle count
   #Number of reported uncorrect
   #Number of command timeout
   #"
   #for item in CONFIG.scsi_devices:
   #   print item

   parser = OptionParser()
   messageLevel=0
   if len(sys_argv)>1:
      if not "-" in sys.argv[1]:
         if sys.argv[1] in ['qa', 'QA']:
            messageLevel=1
         elif sys.argv[1] in ['csr','CSR']:
            messageLevel=2
         elif sys.argv[1] in ['dev']:
            messageLevel=3

   helpDict= {
      'selfhealing':'(Advanced Option) Enable selfhealing as set up in crontab'
      , 'confirm'    :'(Advanced Option) Enable confirmation as set up in crontab'
      , 'install'    :'(Advanced Option) Copy the current directory one into /usr/bp/bin/ and /usr/bp/lib/monitoring'
      , 'fix_cachecade':'Letting support engineer fix in command line'
      , 'lsigetlinux':'Creating MBX Diagnostic File and Upload FTP Site; Current version is lsigetlinux_062514.tgz'
      , 'upload'     :'Enable this option if you want to upload it to ftp site after creating MBX Diagnostic File'
      , 'showVersion':'Show version and ChangeLog'
      , 'debug'      :'Show the embeded command during the job running'
      , 'verbose'    :'With module name provided, you will see the selected debug log message'
      , 'list'       :'Show the list of appliances supported by this script'
      , 'listOfDisks':'Show the list of hard disk drives supported by this script'
      , 'new'        :'Enable new feature before or under review'
      , 'dev'        :'only for development purpose'
      , 'anaLSILog'  :'Analyze LSI log from raid controller'
      , 'detailSMART':'Show detail of SMART information such as temperature, etc'
      , 'testOn'     :'Enable specific test based on test title keyword'
      , 'showscsi'   :'Show Scsi list'
      , 'ana'        :'Do analysis over log file in /var/log/monitoring_disks'
      , 'maxReallocSectorThreshold':'Change threshold of max reallocated sectors (Test Purpose)'
      , 'maxPendingSectorThreshold':'Change threshold of max pending sectors (Test Purpose)'
      , 'cmc_snmptrap_out':'Return output for cmc_snmptrap for the purpose of funneling'
      , 'force_swrebuild':'Rebuild unpartition drive regardless of power on hours (default is less than 10 days)'
      , 'snmpTest'   :'Send Test Trap'
      }

   strings=[]
   # http://mycusthelp.info/LSI/_cs/AnswerDetail.aspx?sSessionID=4368A4345E744951A0A36280ACBFB830HNQKKDWT&inc=8264&caller=~/FindAnswers.aspx?txtCriteria=capture+script&sSessionid=4368A4345E744951A0A36280ACBFB830HNQKKDWT
   strings.append( ("-s", "--selfhealing",      "selfhealing", False, 'store_true', helpDict['selfhealing']) )
   strings.append( ("-c", "--confirm",          "confirm",     False, 'store_true', helpDict['confirm']) )
   strings.append( ("-i", "--install",          "install",     False, 'store_true', helpDict['install']) )

   strings.append( ("",   "--lsigetlinux",      "lsigetlinux", False, 'store_true', helpDict['lsigetlinux']) )
   strings.append( ("",   "--upload",           "upload",      False, 'store_true', helpDict['upload']) )
   strings.append( ("-v", "--version",          "showVersion", False, 'store_true', helpDict['showVersion']) )
   strings.append( ("-d", "--debug",            "debug",       False, 'store_true', helpDict['debug']) )
   strings.append( ("",   "--verbose",          "verbose",     '',    'store',      helpDict['verbose']) )
   strings.append( ("-l", "--listOfAppliances", "list",        False, 'store_true', helpDict['list']) )
   strings.append( ("-k", "--listOfDisks",      "listOfDisks", False, 'store_true', helpDict['listOfDisks']) )
   strings.append( ("",   "--new",              "new",         False, 'store_true', helpDict['new']) )
   strings.append( ("",   "--anaLSILog",        "anaLSILog",   False, 'store_true', helpDict['anaLSILog']) )
   strings.append( ("",   "--detail",           "detailSMART", False, 'store_true', helpDict['detailSMART']) )
   strings.append( ("-t", "--testOn",           "testOn",      '',    'store',      helpDict['testOn']) )
   strings.append( ("-q", "--quick",            "quick",       False, 'store_true', helpDict['testOn']) )
   strings.append( ("",   "--showscsi",         "showscsi",    '',    'store_true', helpDict['showscsi']) )
   strings.append( ("",   "--ana",              "ana",         False, 'store_true', helpDict['ana']) )
   strings.append( ("",   "--maxReallocSectorThreshold",        "maxReallocSectorThreshold",   False, 'store_true', helpDict['maxReallocSectorThreshold']) )
   strings.append( ("",   "--maxPendingSectorThreshold",        "maxPendingSectorThreshold",   False, 'store_true', helpDict['maxPendingSectorThreshold']) )

   strings.append( ("",   "--fix_cachecade",    "fix_cachecade", False, 'store_true', helpDict['fix_cachecade']) )
   strings.append( ("",   "--cmc_snmptrap_out", "cmc_snmptrap_output", False, 'store_true', helpDict['cmc_snmptrap_out']) )
   strings.append( ("",   "--dev",              "dev",         False, 'store_true', helpDict['dev']) )
   strings.append( ("",   "--force_swrebuild",  "force_swrebuild",  False, 'store_true', helpDict['force_swrebuild']) )
   itemname="snmpTest"
   strings.append( ("",   "--%s"%itemname,              "%s"%itemname,         False, 'store_true', helpDict['%s'%itemname]) )
   

   for i in range(len(strings)):
      ntuple =strings[i]
      theHelpFlag=SUPPRESS_HELP
      if messageLevel>2:
         theHelpFlag=ntuple[5]
      elif messageLevel==2:
         if ntuple[2] in ['snmpTest']:
            theHelpFlag=ntuple[5]
      elif messageLevel==1:
         if ntuple[2]=='testOn':
            theHelpFlag=ntuple[5]
         
      parser.add_option(ntuple[0], ntuple[1], dest=ntuple[2], default=ntuple[3], action=ntuple[4], help=theHelpFlag)

   (opts, args) = parser.parse_args()

   if opts.showscsi:
      for scsi in CONFIG.scsi_devices:
         print scsi
      sys.exit(0)   

   CONFIG.fix_cachecade=opts.fix_cachecade
   CONFIG.cmc_snmptrap_output=opts.cmc_snmptrap_output
   CONFIG.runDirname  = dirname
   CONFIG.lsigetlinux = opts.lsigetlinux
   CONFIG.upload      = opts.upload
   CONFIG.debug       = opts.debug
   CONFIG.new         = opts.new
   CONFIG.ana         = opts.ana
   CONFIG.verbose     = opts.verbose
   CONFIG.list        = opts.list
   CONFIG.listOfDisks = opts.listOfDisks
   CONFIG.showVersion = opts.showVersion
   CONFIG.testOn      = opts.testOn
   CONFIG.quick       = opts.quick
   CONFIG.selfhealing = opts.selfhealing
   CONFIG.anaLSILog  = opts.anaLSILog
   CONFIG.confirm     = opts.confirm
   CONFIG.detailSMART = opts.detailSMART
   if CONFIG.quick:   CONFIG.dbON = False
   CONFIG.dev         = opts.dev
   CONFIG.force_swrebuild=opts.force_swrebuild
   #CONFIG.dailySMART  = opts.dailySMART    

   if CONFIG.selfhealing and CONFIG.confirm:
      is_enable_raidInfo=get_master_ini("Monitoring", "Enable_raidInfo")
      if is_enable_raidInfo.lower() in ["no","false"]:
         CONFIG.Enable_raidInfo=False  # default is True

   if dirname == "/root/": # threshold has been increase to reduce cases/CIAs down
                       #Interactive purpose, we want to set the threshold as it should be
      CONFIG.maxPendingSector512  = 0
      CONFIG.maxPendingSectorAF   = 0

   if opts.maxReallocSectorThreshold:
      print "You are changing threshold of realloc sector count!!"
      print "   from %d/%d (512/AF) to %d..." % (CONFIG.maxReallocNumber512, CONFIG.maxReallocNumberAF, int(opts.maxReallocSectorThreshold))
      CONFIG.maxReallocNumber512 = int(opts.maxReallocSectorThreshold)
      CONFIG.maxReallocNumberAF  = int(opts.maxReallocSectorThreshold)

   if opts.maxPendingSectorThreshold:
      print "You are changing threshold of pending sector count!!"
      print "   from %d/%d (512/AF) to %d..." % (CONFIG.maxPendingSector512, CONFIG.maxPendingSectorAF, int(opts.maxPendingSectorThreshold))
      CONFIG.maxPendingSector512  = int(opts.maxPendingSectorThreshold)
      CONFIG.maxPendingSectorAF   = int(opts.maxPendingSectorThreshold)

   if messageLevel:
      parser.print_help()
      sys.exit(0)

   if not CONFIG.cmc_snmptrap_output:
      print "==== Script Version: %s" % CONFIG.scriptVersion
      print "==== %s [%s]  IPADDR: %s  MAC: %s" % (CONFIG.hostname, CONFIG.assetTag, CONFIG.ipaddr, CONFIG.macAddr)
      #for dpuVersion in CONFIG.version:
      print "==== %s" % CONFIG.ver_info
      dpuType = CONFIG.hostType
      now = CONFIG.now
      print "==== %4d-%02d-%02d %02d:%02d:%02d %s" \
         % (now.year, now.month, now.day, now.hour, now.minute, now.second, dpuType)

      if CONFIG.runDirname == "/usr/bp/bin/":
         print "====TRAPDATA,%s,%s,%s" %(CONFIG.asset_mac, CONFIG.host_type, CONFIG.ver_info)

      
   return (opts, args)


def get_nth_word(command, n):
   lines = get_printout(command)
   for line in lines:
      return line.split()[n]
   return "" # this is for null return

def get_last_word(command):
   lines = get_printout(command)
   word =""
   for line in lines:
       words = line.split()
       word = words[len(words)-1]

   return word    

def get_first_word(command):
   return get_nth_word(command,0)

def get_printout(command, doSplit=True):

   if CONFIG.debug: print "# " + command

   if "pdreplacemissing" in command:
      if not CONFIG.confirm:
         print command + " (NOT EXECUTED)"
         line = []
         line.append("Exit Code: 0x01") # needs at least 3 words
         return line
   import commands      

   if doSplit: # To make an array
      return commands.getoutput(command).splitlines()
   else :
      return commands.getoutput(command)

def get_master_ini(section, para):
    return get_first_word("/usr/bp/bin/bputil -g %s %s ERROR /usr/bp/bpinit/master.ini" % (section, para))

def set_master_ini(section, para, value):
    run_command("/usr/bp/bin/bputil -p %s %s %s /usr/bp/bpinit/master.ini" % (section, para, value))
