import os,sys

if not "/usr/bp/lib/monitoring" in sys.path:
   sys.path.append("/usr/bp/lib/monitoring")

from trap_helper import *

######
class Boot:
   def __init__(self,line):
      
      words=line.split("[")
      
      months={
         "Jan":1      ,"Feb":2      ,"Mar":3      ,"Apr":4       ,"May":5       ,"Jun":6
         ,"Jul":7      ,"Aug":8      ,"Sep":9      ,"Oct":10      ,"Nov":11      ,"Dec":12
      }
      
      self.name=words[4].split("]")[0].strip()
      #Mon Jul 04 00:55:14 2016 MDT
      rawDate=words[8].split("]")[0].strip()
      segs=rawDate.split()
      sgs=segs[3].split(":") ## 11:22:33
      date="%02d/%02d %s" %(months[segs[1]],int(segs[2]),segs[4])
      import datetime


      self.tz=segs[5]
      self.datetime=datetime.datetime(int(segs[4]),months[segs[1]],int(segs[2]),int(sgs[0]),int(sgs[1]),int(sgs[2]))
      self.epoch = int(self.datetime.strftime('%s'))
      self.epoch_hex=get_hex(self.epoch,8)
      
   def __repr__(self):
      return "%8s: %s %s %s" %(self.name, self.tz, self.datetime, self.epoch_hex)

##################
if len(sys.argv)<2:
   print "Please, provide an argument start|stop|install"
   sys.exit()

if sys.argv[1] not in ["start","stop","install"]:
   print "Please, provide an argument start|stop|install"
   sys.exit()

action=sys.argv[1]
   
command="/usr/bin/utmpdump /var/log/wtmp  | /bin/grep -E 'reboot|shutdown' | /usr/bin/tac "
boots=[]
import commands
for line in commands.getoutput(command).splitlines():
    if "Utmp dump" in line: continue
    boot=Boot(line)
    boots.append(boot)

prev=None
clean_boots,unclean_boots=[],[]
for boot in boots:
    if boot.name=="reboot":
        if prev!=None and prev.name==boot.name:
            unclean_boots.append(prev)
    prev=boot


for boot in boots:
    if boot in unclean_boots: continue
    if boot.name=="reboot":
        clean_boots.append(boot)

f=open("/var/log/out","w")

title="Reboot"
if action=="stop":
   title="Shutdown"
elif action=="install":
   title="Install"

message =""
if len(clean_boots):
   message ="[%s] %s last clean reboot at %s | " % (title,clean_boots[0].tz,clean_boots[0].epoch_hex)
   message+="unclean reboot# %d :: " % len(unclean_boots)

for i in range(len(unclean_boots)):
    if i>=5: break
    boot=unclean_boots[i]
    message+="%s " % boot.epoch_hex

idx=0
if CONFIG.dbON: idx=1

if not len(message):
   message="[%s] " % title
    
message+="| DBON %d :: %s" %(idx,CONFIG.dbOff_reason)
    
f.write(message+"\n")
f.close()

category_id = 18 # New informational trap
severity=3 #informational
isopen = 0
doSendInfoTrap=True

shortName="AnaReboot"
trapToSend = Trap(category_id, shortName, message, severity, isopen, 206) # This is for version information trap
trapToSend.send_trap(doSendInfoTrap)


#   print len(dates_softshut), len(dates_hardshut)



