import os

class CONFIG:
   pass

CONFIG.debug        =False
CONFIG.confirm      =True
CONFIG.dbON =True
CONFIG.dbOff_reason=""


#CONFIG.selfhealing = False
import commands
CONFIG.CentOS_version = 5
if "el6" in commands.getoutput("/bin/uname -r").splitlines()[0]:
   CONFIG.CentOS_version = 6
CONFIG.version,CONFIG.ver_info =[],""

if os.path.exists("/usr/local/bin/dpu"):
   command = "/usr/local/bin/dpu version"
   CONFIG.version = commands.getoutput(command).splitlines()
   CONFIG.ver_info   = '%s %s' % (CONFIG.version[1], (CONFIG.version[2])[13:])
else:
   command = "/bin/uname -r"
   CONFIG.version = commands.getoutput(command).splitlines()
   CONFIG.ver_info="%s NA" % CONFIG.version[0] 
   
import platform
CONFIG.hostname = platform.node()
CONFIG.assetTag = "000-000-00000"   
CONFIG.modelNo  = "000"
if os.path.exists("/etc/unitrends-asset"):
   CONFIG.assetTag  = open("/etc/unitrends-asset").read().split()[0]   
   CONFIG.modelNo   = open('/etc/unitrends-asset').read().split("-")[0]


CONFIG.ipaddr,CONFIG.macAddr,defaultdevice = "10.10.10.1","MAC NA",""
awk_path='/bin/awk'
if not os.path.exists(awk_path):
   awk_path='/usr/bin/awk'
lines =commands.getoutput("/sbin/ip route | %s '/default/ {print $5}' | /usr/bin/head -n 1" % awk_path).splitlines()
if len(lines) >0:
   defaultdevice=lines[0].split()[0]
   lines=commands.getoutput("/sbin/ip addr show dev %s | %s '/inet.+global/ {print $2}' | /usr/bin/cut -f1 -d'/'"%(defaultdevice,awk_path)).splitlines()
   CONFIG.ipaddr=lines[0].split()[0]
   lines=commands.getoutput("/sbin/ip addr show dev %s | %s '/ether/ {print $2}' "% (defaultdevice,awk_path)).splitlines()
   CONFIG.macAddr= (lines[0].split()[0]).upper()

CONFIG.hostType = "Unknown" # DB dependency
CONFIG.asset_mac ='%s %s'   % (CONFIG.assetTag, CONFIG.macAddr)
CONFIG.host_type  ='%s %s' % (CONFIG.hostname, CONFIG.hostType)

segs = CONFIG.assetTag.split("-")
CONFIG.UB_type,UB_license_type ="","N/A"
if "Metal-" in CONFIG.assetTag:
   CONFIG.UB_type="Metal"


def is_dbON():
   reason,dbON,lines = "",True,commands.getoutput("/bin/ps aux | /bin/grep postgres | /bin/grep data").splitlines()
   # psql: could not fork new process for connection: Cannot allocate memory
   # True 1 ['root      9314  0.0  0.0  63848  1048 pts/2    S+   09:34   0:00 sh -c { ps aux | grep postgres | grep data; } 2>&1']

   lcnt = 0
   for line in lines:
      if "grep" in line:       continue
      lcnt +=1
   if not lcnt:
      dbON = False
      reason="no process postgres running"
      return reason
   
   # without bpdb postgres, you will see the following message from crontab:
   # psql: FATAL:  role "root" does not exist
   lines= commands.getoutput("/usr/bin/psql bpdb postgres -c \"select * from bp.nodes limit 1\"").splitlines()
   for line in lines:
      if "could not access status of transaction" in line or \
         "timeout expired" in line or \
         "Connection refused" in line or \
         "the database system is starting up" in line or \
         "too many clients" in line:
         dbON = False
         reason=line[:-1] # getting rid of return character (\n)
         return reason
      
   # Do not run while VACUUM is running
   lines = commands.getoutput("/bin/ps aux | /bin/grep VACUUM | /bin/grep -v grep").splitlines()
   if len(lines):
      dbON=False
      line=lines[0]
      reason=line[:-1]
      return reason
   
   return reason

CONFIG.dbOff_reason=is_dbON()   
CONFIG.dbON = not len(CONFIG.dbOff_reason)

if CONFIG.dbON:
   lines = commands.getoutput("/usr/bin/psql -U postgres bpdb -tq -c  \"select item_value from bp.nvp where item_name='Identity'\" | head -1").splitlines()
   if len(lines):
      CONFIG.hostType = lines[0].strip()

   lines = commands.getoutput("/usr/bin/psql -U postgres bpdb -tq -c \"SELECT psa_tool_name FROM bp.psa_config JOIN bp.psa_tools USING (psa_tool_id) WHERE is_default=true\" | grep -v ^$").splitlines()   
   if len(lines):
      words = lines[0].split()
      CONFIG.psaON=words[0].strip()

if len(segs) >3: # this is for UB #60b099ac-7e7e-42dd-bb96-bda073927077
   if len(commands.getoutput("/sbin/lsmod | /bin/grep vmxnet").splitlines()):
      CONFIG.UB_type = "VMWare"
   elif len(commands.getoutput("/sbin/lsmod | /bin/grep vmbus").splitlines()):  
      CONFIG.UB_type = "HyperV"
   elif len(commands.getoutput("/sbin/lsmod |grep xen_netfront")):
      CONFIG.UB_type = "XenSer"
              
   bptool_lines=commands.getoutput("/usr/bp/bin/bptool -v 2>&1| /bin/grep -E 'Feature:'").splitlines()
   if len(bptool_lines):
      theLine =bptool_lines[0]
      #Feature:  ENTRB,MUX=10,VC=INF,RC=INF,D2D=INF,ENC,ADX
      theWord =theLine.split()[1]
      UB_license_type =theWord.split(",")[0]

if not len(CONFIG.UB_type):
   lines=commands.getoutput("/bin/grep Server1 /var/log/install-rr.log | /bin/grep 'set to'").splitlines()
   if len(lines):
      sgs=(lines[0]).split()
      if len(sgs)>=4:
         theWord=sgs[3]
         if "Xen"    in theWord: CONFIG.UB_type="XenSer"
         if "VMware" in theWord: CONFIG.UB_type="VMWare"
         if "Hyper"  in theWord: CONFIG.UB_type="HyperV"

if not len(CONFIG.UB_type):
   if "VMware_"  in CONFIG.hostname: CONFIG.UB_type="VMWare"
   if "Hyper-V_" in CONFIG.hostname: CONFIG.UB_type="HyperV"
   if "Xen_"     in CONFIG.hostname: CONFIG.UB_type="XenSer"

CONFIG.host_type +=" %s %s" % (CONFIG.UB_type, UB_license_type)


def str2bool(v):
    return v.lower() in ("yes", "true", "t", "1")

class snmp_config:
   def __init__(self, line):
      values = line.split("|")
      self.id = int(values[0])
      self.destination = values[1].strip()
      self.community   = values[2].strip()
      self.enabled = str2bool(values[3].strip())

   def __repr__(self):
      return "id: %2d   destination: %30s   community: %s   enabled: %s" % (self.id, self.destination, self.community, self.enabled)


def get_db_entries(name, host='localhost', start='',end=''):
   objects = []
   command =""
   filename = "/var/log/monitoring_disks/bp.%s.dbout" % (name)
   if CONFIG.dbON:
      # bp.notifications, application_instances, replication_queue, operation_progress
      # bp.backup_reps, vmware_esx_servers, xen_servers, application_lookup
      # bp.nodes, backups
      # default query
      query ="SELECT * FROM bp.%s" % name
      command ="/usr/bin/psql bpdb postgres -tq -c \"%s\" | grep -v ^$" % query

      if name == "snmp_config" or name == "notifications": # make a result saved in the log
         if not os.path.exists("/var/log/monitoring_disks"):
            os.system("/bin/mkdir /var/log/monitoring_disks")
         os.system("%s > %s" % (command, filename) )

   else:
      if os.path.exists(filename):
         command = "/bin/cat %s" % filename
      else:
         return objects

   if CONFIG.debug:
      print "get_db_entries()"
      print "     ", command
      
   #import commands
   lines = commands.getoutput(command).splitlines()
   for line in lines:
      if "ERROR" in line or "LINE" in line or len(line.split("|"))<2: continue

      if "snmp_config" in name:
         object = snmp_config(line)
         
      objects.append(object)

   return objects   
            
CONFIG.bpdb_snmp_config   = get_db_entries("snmp_config")

#### CLASS
class Trap:
    def __init__(self, category_id, identifier, message, severity, status, notification_id=999, aux=[]):
                                                                                              
        import datetime
        now = datetime.datetime.now()

        self.asset_mac, self.host_type  = CONFIG.asset_mac, CONFIG.host_type
        self.hostname,  self.ver_info   = CONFIG.hostname,  CONFIG.ver_info

        self.category_id = category_id
        self.htime, self.epoch = now, now.strftime('%s')

        #trap_type_id: 18  is Informational Trap
        trap_type_id    = category_id
        self.type       = "Informational Trap"  # This is for 18
        self.notification_id = notification_id
        self.username = "root"

        self.alert, self.trap, self.log, self.email, self.psa    = False, True, False, False, False
        self.identifier,self.message,self.severity,self.status,self.closed = identifier,message,severity,status,'t'
        if int(status):  # open
           self.closed  = 'f'

        self.rows = {    0: ("OID",                 "enterprises.21865.1.2.100.0.%d" %trap_type_id, "") # 99: Test  40: originated by disk_monitoring script
                      ,  1: ("Type",                "enterprises.21865.1.1.1",        "s")
                      ,  2: ("Identifier",          "enterprises.21865.1.1.2",        "s")
                      ,  3: ("Message",             "enterprises.21865.1.1.3",        "s")
                      ,  4: ("Severity",            "enterprises.21865.1.1.4",        "i") # 1: FATAL  2: WARNING  3: NOTICE  4: VERBOSE
                      ,  5: ("Status",              "enterprises.21865.1.1.5",        "i") # 0: Clear/Close  1: Raise/Open
                      ,  6: ("Asset/MAC",           "enterprises.21865.1.1.6",        "s")
                      ,  7: ("Hostname/Type",       "enterprises.21865.1.1.7",        "s")
                      ,  8: ("Version/InstallDate", "enterprises.21865.1.1.8",        "s")
                      ,  9: ("auxiliary",           "enterprises.21865.1.1.9",        "s")
                      , 10: ("auxiliary",           "enterprises.21865.1.1.10",       "s")
                      , 11: ("auxiliary",           "enterprises.21865.1.1.11",       "s")
                      , 12: ("auxiliary",           "enterprises.21865.1.1.12",       "s")
                      , 13: ("auxiliary",           "enterprises.21865.1.1.13",       "s")
                      , 14: ("auxiliary",           "enterprises.21865.1.1.14",       "s")
                      , 15: ("auxiliary",           "enterprises.21865.1.1.15",       "s")
                      , 16: ("auxiliary",           "enterprises.21865.1.1.16",       "s")
                      , 17: ("auxiliary",           "enterprises.21865.1.1.17",       "s")
                      , 18: ("auxiliary",           "enterprises.21865.1.1.18",       "s")
                      , 19: ("auxiliary",           "enterprises.21865.1.1.19",       "s")
        }                                           

        objs = ['']
        objs.append(self.type)
        objs.append(self.identifier)
        objs.append(self.message)
        objs.append(self.severity)
        objs.append(self.status)
        objs.append(self.asset_mac)
        objs.append(self.host_type)
        objs.append(self.ver_info)
        for i in range(len(aux)):
           objs.append(aux[i])
        self.objs = objs

    def __repr__(self):
        output = ""
        for i in range(len(self.objs)):
            objOID  = self.rows[i][1]
            if i==0:
                output += "%s%s\n" % (objOID, self.objs[i])
            else:
                output += "%s:= %s\n" % (objOID, self.objs[i])
        return output    

    def send_trap(self, doSendInfoTrap=False):  # log as well
        # community and ipaddress should be from bp.snmp_config table
        isLogged = False

        for snmp_cfg in CONFIG.bpdb_snmp_config:
            if not CONFIG.confirm:
               print "[Testing Purpose] NOT confirmed and showing the message::  %s" % self.message
               
            if self.log and not isLogged:
               self.book_to_audit_history()
               isLogged = True

            if snmp_cfg.enabled and self.trap and CONFIG.confirm:
               # Do booking
               if CONFIG.dbON:    
                  theMessage = self.message
                  ####
                  # As of 3/10/2016, we resume sending traps for automated warranty replacement
                  ####
                  #if not (self.severity ==1 or doSendInfoTrap):  ## Trap sent only when FATAL or Informational Trap
                  #   theMessage += " >>NOTSENT"

                  if CONFIG.debug:   
                     print "trap.py:: %s" %theMessage  
                  
                  query  = "INSERT INTO bp.snmp_history (oid, destination, community, traptype, object, description, severity, status) "
                  query += "VALUES ('%s','%s','%s','%s','%s','%s',%s,%s)" \
                           % (self.rows[0][1], snmp_cfg.destination, snmp_cfg.community, self.type, self.identifier, theMessage, self.severity, self.status)
                  if CONFIG.debug:
                     print query
                  self.run_query(query)
               else:
                  if not os.path.exists("/var/log/monitoring_disks/bp.snmp_history.dbout"):
                     os.system("echo > /var/log/monitoring_disks/bp.snmp_history.dbout")
                     
                  dbentry = " 0 | %s | %s | %s | %s | %s | %s | %s | %s | %s " \
                            % (self.rows[0][1], self.htime, snmp_cfg.destination, snmp_cfg.community, self.type, self.identifier, self.severity, self.status, self.message)
                  if CONFIG.debug:
                     print dbentry
                  os.system("echo '%s' >> /var/log/monitoring_disks/bp.snmp_history.dbout" % dbentry)

               # Do send
               ####
               # As of 3/10/2016, we resume sending traps for automated warranty replacement
               ####
               if True or self.severity == 1 or doSendInfoTrap:  # Sometimes, I don't send a trap but logging into snmp_history

                  command = "/usr/bin/snmptrap -v 2c -c %s %s '' " % (snmp_cfg.community, snmp_cfg.destination)
                  cnt_char=0
                  for i in range(len(self.objs)):
                     objOID  = self.rows[i][1]
                     objType = self.rows[i][2] # either string or integer
                     if objType == "s":
                        command += "%s %s '%s' " % (objOID, objType, self.objs[i])
                     else:
                        command += "%s %s %s "   % (objOID, objType, self.objs[i])
                        
                     cnt_char+=len(objOID)
                     cnt_char+=len(objType)
                     if isinstance(self.objs[i],int):
                        cnt_char+=len("%d"%self.objs[i])
                     else:
                        cnt_char+=len(self.objs[i])
                                                                                                                                 
                  if CONFIG.debug:
                     print "trap.py:: %s :total number of characters %d; can hold up to <=1658" %(command,cnt_char)
                  if not CONFIG.debug:
                     os.system(command)

                                                            

    def book_to_alerts(self): # psa as well   
       #if self.test: return # this is designed for trap only 
        
       if self.alert:
          query  = "INSERT INTO bp.alerts (alert_text, source_id, target, severity, created, updated, closed, notification_id) "
          query += "VALUES ('%s',%d,'%s',%s,%s,%s,'%s',%d)" % (self.message, self.category_id, self.identifier, self.severity, self.epoch, self.epoch, self.closed, self.notification_id)
          if CONFIG.confirm and self.severity==1 :
             self.run_query(query) # not attempted if dbON=False

       if len(CONFIG.psaON) and self.severity==1 and self.psa:
          if not CONFIG.debug and CONFIG.confirm:
             os.system("/usr/bp/bin/cmc_psa %s %d '%s'" % (CONFIG.psaON, self.notification_id, self.message))
       return

    def book_to_audit_history(self):
        query  = "INSERT INTO bp.audit_history (notification_id, event_time, username, system, message) "
        query += "VALUES (%d, '%s','%s','%s','%s')" % (self.notification_id, self.htime, self.username, self.hostname, self.message)

        if CONFIG.debug:
           print query
        
        # To avoid flooding insert calls every 30 minutes when database is locked
        #import commands
        command ="/bin/ps aux | /bin/grep 'INSERT INTO bp.audit_history' | /bin/grep diskmon"
        lines=commands.getoutput(command).splitlines()
        nline= len(lines)
        if (nline-1)<1:  # need to exclude self
           if CONFIG.confirm:
              if CONFIG.debug: print query
              self.run_query(query)
        return

    def run_command(self, command, secondsToSleep=0):
        message = "Executing # %s " % command
        if CONFIG.confirm:
            #print message
            os.system(command)
            if secondsToSleep>0:
                import time
                time.sleep(secondsToSleep)
        else:
            message = message + " (NOT EXECUTED)"
            print message
   
        return

    def run_query(self, query):
        command = "/usr/bin/psql bpdb postgres -c \"%s\" >/dev/null 2>&1" % query
        if CONFIG.dbON:
            self.run_command(command)
        return


def get_hex(value,n_digit):
    hex_value=hex(value)[2:]
    for i in range(n_digit-len(hex_value)):
        hex_value="0"+hex_value
    return hex_value
